%Written by Carita Gyldenskog Ranvik, Trondheim 10.06.2019
function [P_B,sfoc,V_isl]=FuelPower(AddedRes,...
    Hs_int,Tp_int,Vaw_int,h_int,Tp,Hs,Vreq,heading)

t_start=cputime;

%Fuel stat data
%This script creates the fuel consumption matrix for Tp, Hs and speed
%combinations for statistical fuel consumption calultaions
%[t_p,h_s,heading=0 degrees (Only head waves),v]

%ENGINE CHARACTERISTICS
addpath('M:\carita\Prepocessing of data for simulation V5\Engine Characteristics')
load('Engine_characteristics.mat','Eng_load','eta_M','P_rated');
% 
% %DATA
% addpath('C:\Users\Carita\OneDrive for Business\Skole\Master Thesis\MATLAB code\preprocessing fo data for simulation\Added Resistance')
% load('AddedRes_range.mat');
% load('AddedRes_clean.mat');
% 
% 
% %Setting ranges for tp, hs and v
% Tp=3:24;
% Hs=1:14;
% Vreq=3:18;
% heading=0:15:345;

%Declearing variables
V_isl=zeros(length(Hs),length(Tp),length(Vreq),length(heading)); %involuntary speed loss
e_load=zeros(length(Hs),length(Tp),length(Vreq),length(heading));
sfoc=zeros(length(Hs),length(Tp),length(Vreq),length(heading));
P_B=zeros(length(Hs),length(Tp),length(Vreq),length(heading));
r_T0=zeros(length(Hs),length(Tp),length(Vreq),length(heading));
r_AW=zeros(length(Hs),length(Tp),length(Vreq),length(heading));
R_T=zeros(length(Hs),length(Tp),length(Vreq),length(heading));

for l=1:length(heading)
    for i=1:length(Vreq)
        for j=1:length(Hs)
            for k=1:length(Tp)
                %Calm water resistance
                r_T0(j,k,i,l)=calm_water_res(Vreq(i));

                % Added resistance 
                r_AW(j,k,i,l)=interpn(Hs_int,Tp_int,Vaw_int,h_int,AddedRes,Hs(j),Tp(k),Vreq(i),heading(l));

                %Total resistance
                R_T(j,k,i,l)=r_T0(j,k,i,l)+r_AW(j,k,i,l);

                %Power consumption
                [P_B(j,k,i,l), ~]=Break_power(R_T(j,k,i,l),Vreq(i),eta_M); %[W] 

                %Engine load    
                e_load(j,k,i,l)=P_B(j,k,i,l)/P_rated;


                    if e_load(j,k,i,l)<=1 && e_load(j,k,i,l)>=Eng_load(1) || e_load(j,k,i,l)<Eng_load(1)
                        V_isl(j,k,i,l) = Vreq(i);
                        sfoc(j,k,i,l)=fuel_con(e_load(j,k,i,l));

                    else
                        [sfoc(j,k,i,l),P_B(j,k,i,l),e_load(j,k,i,l),...
                            V_isl(j,k,i,l),R_T(j,k,i,l),r_T0(j,k,i,l),r_AW(j,k,i,l)]=...
                            ivsl_FuelPower(Vreq(i),Hs(j),Tp(k),heading(l),AddedRes,Hs_int,Tp_int,Vaw_int,h_int); 
                    end

            end
        end
    end
end
t_tot=(cputime-t_start)/(60*60);
disp(t_tot)
filename=sprintf('FuelPowerWorkspace_Hs%.1fto%.1f.mat',Hs(1),Hs(end));
save(filename,'P_B','e_load','R_T','r_T0','r_AW','V_isl','Tp','Hs','Vreq','sfoc','t_tot')

end    
