%Written by Carita Gyldenskog Ranvik, Trondheim 10.06.2019
function [V_isl,Tp_isl,Hs_isl]=Invol_speed_loss(AddedRes_headwaves,Hs_interp,Tp_interp,Vaw_interp,Hs,Tp,Vlim)
t_start=cputime;
%Fuel stat data
%This script creates the fuel consumption matrix for Tp, Hs and speed
%combinations for statistical fuel consumption calultaions
%[t_p,h_s,heading=0 degrees (Only head waves),v]

%ENGINE CHARACTERISTICS
addpath('C:\Users\Carita\OneDrive for Business\Skole\Master Thesis\MATLAB code\Prepocessing of data for simulation V3\Engine Characteristics')
load('Engine_characteristics.mat','Eng_load','eta_M','P_rated');

%DATA
% addpath('C:\Users\Carita\OneDrive for Business\Skole\Master Thesis\MATLAB code\preprocessing fo data for simulation\Added Resistance')
% load('HsTpVaw_mesh.mat');
% load('AddedRes_headwaves.mat');


% %Setting ranges for tp, hs and v
% Tp=3:24;
% Hs=1:14;
% Vlim=18;

%Declearing variables
V_isl=zeros(length(Hs),length(Tp)); %involuntary speed loss
e_load=zeros(length(Hs),length(Tp));
%Fuel_con_headwaves=zeros(length(h_s),length(t_p),length(v));
P_B=zeros(length(Hs),length(Tp));
r_T0=zeros(length(Hs),length(Tp));
r_AW=zeros(length(Hs),length(Tp));
R_T=zeros(length(Hs),length(Tp));


for j=1:length(Hs)
    for k=1:length(Tp)
        %Calm water resistance
        r_T0(j,k)=calm_water_res(Vlim);

        % Added resistance 
        r_AW(j,k)=interp3(Tp_interp,Hs_interp,Vaw_interp,AddedRes_headwaves,Tp(k),Hs(j),Vlim);

        %Total resistance
        R_T(j,k)=r_T0(j,k)+r_AW(j,k);

        %Power consumption
        [P_B(j,k), ~]=Break_power(R_T(j,k),Vlim,eta_M); %[W] 

        %Engine load    
        e_load(j,k)=P_B(j,k)/P_rated;


            if e_load(j,k)<=1 && e_load(j,k)>=Eng_load(1) || e_load(j,k)<Eng_load(1)
                V_isl(j,k) = Vlim;
                %Fuel_con_headwaves(j,k)=fuel_con(e_load(j,k));

            else
                [P_B(j,k),e_load(j,k),...
                    V_isl(j,k),R_T(j,k),r_T0(j,k),r_AW(j,k)]=...
                    ivsl(Vlim,Hs(j),Tp(k),AddedRes_headwaves,Tp_interp,Hs_interp,Vaw_interp); 
            end

    end
end
Tp_isl=Tp;
Hs_isl=Hs;
t_tot=(cputime-t_start)/(60*60);
disp(t_tot)
save('isl_workspace','P_B','e_load','R_T','r_T0','r_AW','V_isl','Tp','Hs','Vlim','t_tot')

end
    
