%Written by Carita Gyldenskog Ranvik, Trondheim 10.06.2019
%In this script iteration for unvoluntary speed loss is performed
function [P_B,e_load,v_uvsl,R_T,r_T0,r_AW]=ivsl(v,h_s,t_p,AddedRes_headwaves,Tp_interp,Hs_interp,Vaw_interp)
%--------------------------------------------------------------------------
%Fuel stat data
%This script creates the fuel consumption matrix for Tp, Hs and speed
%combinations for statistical fuel consumption calultaions
%[t_p,h_s,heading=0 degrees (Only head waves),v]
%Engine Characetristics
addpath('C:\Users\Carita\OneDrive for Business\Skole\Master Thesis\MATLAB code\Prepocessing of data for simulation V3\Engine Characteristics')
load('Engine_characteristics.mat','eta_M','P_rated');


%Added resistance data
% addpath('C:\Users\Carita\OneDrive for Business\Skole\Master Thesis\MATLAB code\preprocessing fo data for simulation\Added Resistance')
% load('AddedRes_headwaves.mat');
% load('HsTpVaw_mesh.mat');

%--------------------------------------------------------------------------
L=0;
H=v;
step=0.01;
e_c=10;
e_a=1; %diff of 1 w between required and installed
                    
while e_c > e_a
    v_iter=H:-step:L;
    for l=2:length(v_iter)
        r_T0_intp=calm_water_res(v_iter(l));
        r_AW_intp=interp3(Tp_interp,Hs_interp,Vaw_interp,AddedRes_headwaves,t_p,h_s,v_iter(l));
        R_T_intp=r_T0_intp+r_AW_intp;
        [P_B_intp, ~]=Break_power(R_T_intp,v_iter(l),eta_M); %[W] need to check unit
        diff=P_B_intp-P_rated;
        if diff<0 && v_iter(l)>0
            L=v_iter(l);
            H=v_iter(l-1);
            r_T0_intp=calm_water_res(L);
            r_AW_intp=interp3(Tp_interp,Hs_interp,Vaw_interp,AddedRes_headwaves,t_p,h_s,L);
            R_T_intp=r_T0_intp+r_AW_intp;
            [P_B_intp, ~]=Break_power(R_T_intp,L,eta_M); %[W] need to check unit
            e_load_intp=P_B_intp/P_rated;
            diff=P_B_intp-P_rated;
            e_c=diff;
            step=step/10;
            break 
        elseif l==length(v_iter) || isnan(diff)
            P_B_intp=P_rated;
            r_T0=0; %hvorfor?
            r_AW_intp=interp3(Tp_interp,Hs_interp,Vaw_interp,AddedRes_headwaves,t_p,h_s,v_iter(l)); %forklar
            R_T_intp=r_T0_intp+r_AW_intp; %forklar
            e_load_intp=10^-6;
            e_c=e_a;
        end
    end
    r_T0=r_T0_intp; 
    r_AW=r_AW_intp;
    R_T=R_T_intp;
    P_B=P_B_intp;
    e_load=e_load_intp;
    %Fuel_con_headwaves=fuel_con(e_load);
    v_uvsl = v_iter(l);  
end
                    
end
