%Written by Carita Gyldenskog Ranvik, Trondheim 10.06.2019
function [V_vsr]=vsr(hs,tp,heading)

addpath('M:\carita\Prepocessing of data for simulation V5\Operational limits ShipX')
load('oplim_allcrit_workspace.mat');

[V_interp,Tp_interp,h_interp]=meshgrid(v_vec,Tp_vec,h_vec);
vlim=v_vec(end);
hs_lim=interp3(V_interp,Tp_interp,h_interp,oplim_allcrit,vlim,tp,heading);
if hs<hs_lim
    V_vsr=vlim;
else
    L=0;
    H=vlim;
    step=0.1;
    e_c=1;
    e_a=0.01; %diff between Hs and Hslim in meters
                    
    while e_c > e_a
        v_iter=H:-step:L;
        for l=2:length(v_iter)
            hs_lim=interp3(V_interp,Tp_interp,h_interp,oplim_allcrit,v_iter(l),tp,heading);
            diff=hs-hs_lim;
            if diff<0
                L=v_iter(l);
                H=v_iter(l-1);
                hs_lim=interp3(V_interp,Tp_interp,h_interp,oplim_allcrit,v_iter(l),tp,heading);
                diff=hs-hs_lim;
                e_c=diff;
                step=step/10;
                break 
            elseif l==length(v_iter) && hs>hs_lim
                V_vsr=0;
                return
            end
        end 
        V_vsr=v_iter(l);
    end
end
end


